<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Admin_Teachers extends Controller_UserEnvi {

    public function action_index()
    {
        // VIEW
        $twig = Twig::factory('admin/teachers/index');
        $twig->Faculties = $this->getFaculties();
        $twig->User = $this->UserInfo;
        $this->response->body($twig);
    }
    
    public function action_add()
    {
        $twig = Twig::factory('admin/teachers/add');
        $twig->JobPositions = $this->getJobPositions();
        $twig->Faculties = $this->getFaculties();
        $twig->User = $this->UserInfo;
        $this->response->body($twig);
    }
    
    public function action_upload()
    {
        if(!empty($_FILES['teachers']) AND $this->request->method() == 'POST')
        {
            $result = $this->parseFile($_FILES["teachers"]["tmp_name"]);
        }
        // VIEW
        $twig = Twig::factory('admin/teachers/upload');
        $twig->Faculties = $this->getFaculties();
        $twig->UploadingResult = $result;
        $twig->User = $this->UserInfo;
        $this->response->body($twig);
    }    
    
    protected function parseFile($filename)
    {
        return FileParser::TeachersList($filename);
    }
    
    public function getFaculties()
    {
        $model = new Model_Admin_Teachers;
        $faculties = $model->getFaculties();
        $facultiesHandled = array(); $i = 0;
        foreach($faculties as $row)
        {
            $i++;
            $facultiesHandled[$i]['ID'] = $row['FacultyID'];
            $facultiesHandled[$i]['Name'] = $row['FacultyName'];
            $facultiesHandled[$i]['Abbr'] = $row['FacultyAbbr'];
        }
        return $facultiesHandled;
    }
    
    public function getJobPositions()
    {
        $model = new Model_Admin_Teachers;
        $jobPositions = $model->getJobPositions();
        $jobPositionsHandled = array(); $i = 0;
        foreach($jobPositions as $row)
        {
            $i++;
            $jobPositionsHandled[$i]['ID'] = $row['ID'];
            $jobPositionsHandled[$i]['Name'] = $row['Name'];
            // $jobPositionsHandled[$i]['Abbr'] = $row['Abbr'];
        }
        return $jobPositionsHandled;
    }
            
}           