<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_AdmAccounts extends Controller_Handler {
        
        public function before() {
            $this->model = new Model_Admin_Accounts();
            $this->setAccessLevel(self::ACCESS_USER);
            parent::before();
        }
        
        public function action_getActivationForTeachers()
        {
            $facultyID = $this->post->offsetGet('facultyID');
            $departmentsHandled = array(); $i = 0;
            $departments = $this->model->getDepartmentsByFaculty($facultyID);
            foreach ($departments as $department)
            {
                $i++; $j = 0;
                $accounts = $this->model->getTeachersByDepartment($department['DepID']);
                $departmentsHandled[$i]['Name'] = $department['DepName'];
                foreach ($accounts as $row)
                {
                    $accInfo = $this->model->getAccountInfoByID($row['TeacherAccID']);
                    if($code = $accInfo->get('AccCode'))
                    {
                        $j++;
                        $departmentsHandled[$i]['People'][$j]['LastName'] = $row['TeacherLast'];
                        $departmentsHandled[$i]['People'][$j]['FirstName'] = $row['TeacherFirst'];
                        $departmentsHandled[$i]['People'][$j]['SecondName'] = $row['TeacherSecond'];
                        $departmentsHandled[$i]['People'][$j]['ActivationCode'] = $code;
                    }
                }
                if($j == 0)
                {
                    $departmentsHandled[$i] = array();
                    $i--;
                }
            }
            if($i > 0)
            {
                $this->_sendPDF('activationTeachers'.$facultyID, 
                        'pdf/activationTeacher',
                        array('Departments' => $departmentsHandled, 'System' => array('Title' => ASSEMBLY_SYSTEM_NAME, 'Version' => ASSEMBLY_VERSION)));
            }
            else {
                throw HTTP_Exception::factory(404, 'No data found');
            }
        }
        
        public function action_getActivationForStudents()
        {
            $facultyID = $this->post->offsetGet('facultyID');
            $gradeNum = $this->post->offsetGet('gradeNum');
            $groupsHandled = array(); $i = 0;
            $studyGroups = $this->model->getStudyGroups($gradeNum, $facultyID);
            foreach ($studyGroups as $group)
            {
                $i++; $j = 0;
                $accounts = $this->model->getStudentsByStudyGroups($group['GroupID']);
                $groupsHandled[$i]['Grade'] = $gradeNum;
                $groupsHandled[$i]['Num'] = $group['GroupNum'];
                $groupsHandled[$i]['Spec'] = $group['SpecName'];
                foreach ($accounts as $row)
                {
                    $accInfo = $this->model->getAccountInfoByID($row['StudentAccID']);
                    if($code = $accInfo->get('AccCode'))
                    {
                        $j++;
                        $groupsHandled[$i]['People'][$j]['LastName'] = $row['StudentLast'];
                        $groupsHandled[$i]['People'][$j]['FirstName'] = $row['StudentFirst'];
                        $groupsHandled[$i]['People'][$j]['SecondName'] = $row['StudentSecond'];
                        $groupsHandled[$i]['People'][$j]['ActivationCode'] = $code;
                    }
                }
                if($j == 0)
                {
                    $groupsHandled[$i] = array();
                    $i--;
                }
            }
            if($i > 0)
            {
            $this->_sendPDF('activationStudents'.$facultyID.'-'.$gradeNum, 
                    'pdf/activationStudent',
                    array('Groups' => $groupsHandled, 'System' => array('Title' => ASSEMBLY_SYSTEM_NAME, 'Version' => ASSEMBLY_VERSION)));
            }
            else {
                throw HTTP_Exception::factory(404, 'No data found');
            }
        }
        
        protected function _sendPDF($filename, $template, $data)
        {
            $mpdf = View_MPDF::factory($template, $data);
            $cssPath = 'media/css/pdf/activationTemplate.css';
            $css = file_get_contents($cssPath);
            $mpdf->get_mpdf()->WriteHTML($css, 1);
            $this->response->headers('Set-Cookie',  'fileDownload=true; path=/');
            $this->response->headers('Content-Type',  'application/octet-stream');
            $this->response->headers('Accept-Ranges', 'bytes');
            $this->response->headers('Content-Length', strlen($mpdf));
            $this->response->headers('Content-Disposition',  'attachment; filename='.$filename.'.pdf');
            $this->response->headers('Content-Transfer-Encoding',  'Binary');
            $this->response->body($mpdf);
        }
}