<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Settings extends Controller_Handler {
       
        public function before() {
            $this->setAccessLevel(self::ACCESS_USER);
            parent::before();   
        }

        public function action_changeLogin()
        {
            $config = Kohana::$config->load('security.securityPolicy');
            $this->post->rule('login', $config['login']['allowedSymbols'])->rule('login', 'not_empty');
            $arr['success'] = true; 
            $login = $this->post->offsetGet('login');
            if(!$this->post->check())
            {
                $arr['success'] = false;
                $arr['errors'] = $this->post->errors();
                $this->response->body(json_encode($arr));
                return;
            }
            if(!User::instance()->changeLogin($login))
            {
                $arr['success'] = false;
                $this->post->error('login', 'already_exists');
                $arr['errors'] = $this->post->errors();
                $this->response->body(json_encode($arr));
                return;
            }
            $this->response->body(json_encode($arr));
        }
        
        public function action_changePassword()
        {
            $config = Kohana::$config->load('security.securityPolicy');
            $this->post
                ->rule('password', 'min_length', array(':value', $config['password']['length']))
                ->rule('confirm_password', 'matches', array(':validation', 'confirm_password', 'password'));
            $arr['success'] = true; 
            $old = $this->post->offsetGet('old_password');
            $new = $this->post->offsetGet('password');
            if(!$this->post->check())
            {
                $arr['success'] = false;
                $arr['errors'] = $this->post->errors();
                $this->response->body(json_encode($arr));
                return;
            }
            if(!User::instance()->changePassword($old, $new))
            {
                $arr['success'] = false;
                $this->post->error('login', 'invalid_password');
                $arr['errors'] = $this->post->errors();
                $this->response->body(json_encode($arr));
                return;
            }
            $this->response->body(json_encode($arr));       
        }
        
        public function action_editProfile()
        {
            $this->post
                    ->rule('firstName', 'not_empty')
                    // ->rule('firstName', 'alpha_dash', array(':value', TRUE))
                    // ->rule('secondName', 'not_empty')
                    // ->rule('secondName', 'alpha_dash', array(':value', TRUE))
                    ->rule('lastName', 'not_empty')
                    // ->rule('lastName', 'alpha_dash', array(':value', TRUE))
                    ->rule('jobPositionID', 'not_empty')
                    ->rule('jobPositionID', 'digit')
                    ->rule('departmentID', 'not_empty')
                    ->rule('departmentID', 'digit');
            if($this->post->check())
            {
                User::instance()->changeProfile($this->post->data());
            }
        }
        
        public function action_getDepartmentsList()
        {
            $facultyID = $this->post->offsetGet('facultyID');
            $deps = DataArray::factory('Departments')->byFaculty($facultyID)->asArray();
            $this->response->body(json_encode($deps));  
        }
        
        public function action_changeEMail()
        {
            $this->post->rule('email');
            // if(Account::instance()->changeMail())
        }
        
        public function action_confirmNewEMail()
        {
            
        }
}