<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Teacher_Index extends Controller_UserEnvi {

    public function action_index()
    {
        $twig = Twig::factory('teacher/index');
        
        $model = new Model_Teacher_Index;
        $disciplines = $model->getDisciplinesForTeacher($this->UserInfo['TeacherID']);
        $subjID = $discID = $gradeNum = $i = $j = $k = 0; // Combo!!!
        $disciplinesHandled = array();
        $groupsInDiscipline = array();
        $degrees = array('bachelor' => 'Бакалавриат', 'specialist' => 'Специалитет', 'master' => 'Магистратура');
        foreach ($disciplines as $row) {
            if($subjID != $row['SubjectID'] || $gradeNum != $row['GradeID'])
            {
                $i++; $j = $k = 0;
                $groupsInDiscipline = array();
                $subjID = $row['SubjectID'];
                $gradeNum = $row['GradeID'];
                $disciplinesHandled[$i]['Title'] = $row['SubjectName'];
                $disciplinesHandled[$i]['GradeNum'] = $row['GradeNum'];                
                $disciplinesHandled[$i]['Degree'] = $degrees[$row['Degree']];                
                               
            }
            
            if($discID != $row['ID'])
            {
                $j++; $k = 0;
                $groupsInDiscipline = array();
                $disciplinesHandled[$i]['Disciplines'][$j]['isAuthor'] = $row['isAuthor'];
                $disciplinesHandled[$i]['Disciplines'][$j]['isLocked'] = $row['isLocked'];            
                $disciplinesHandled[$i]['Disciplines'][$j]['isMapCreated'] = $row['isMapCreated']; 
                $disciplinesHandled[$i]['Disciplines'][$j]['ID'] = $discID = $row['ID'];
                $disciplinesHandled[$i]['Disciplines'][$j]['ControlType'] = $this->getControlType($row['ExamType']);
                $disciplinesHandled[$i]['Disciplines'][$j]['Teachers'] = $this->getTeachersForDiscipline($discID);
            }
            if($row['GroupNum'] != 0)
                $groupsInDiscipline[++$k] = $row['GroupNum'].' гр.';
            $disciplinesHandled[$i]['Disciplines'][$j]['Groups'] = implode(', ', $groupsInDiscipline);
        } //!for_each
        $twig->Subjects = $disciplinesHandled;
        $twig->User = $this->UserInfo;

        $this->response->body($twig);
    }
    
    public function action_settings() {
        $twig = Twig::factory('settings');
        $twig->User = $this->UserInfo;
        $this->response->body($twig);
    }
    
    protected function getControlType($type)
    {
        if($type == 'exam')
        {
            return 'Экзамен';
        }
        elseif($type == 'credit')
        {
            return 'Зачет';
        }
    }
    
    protected function getTeachersForDiscipline($id) {
        $model = new Model_Teacher_Index;
        $teachers = $model->getTeachersForDiscipline($id);
        $teachersHandled = array(); $i = 0;
        foreach ($teachers as $teacher)
        {
            $i++;
            $teachersHandled[$i] = $teacher['Last'].' '.UTF8::substr($teacher['First'], 0, 1).'. ';
            if(!empty($teacher['Second']))
            {
                $teachersHandled[$i] .= UTF8::substr($teacher['Second'], 0, 1).'.';
            }
        }
        return $teachersHandled;
    }
}