<?php

class DataArr_Teachers {

    protected $model;
    
    public function __construct() {
        $this->model = new Model_DataArr_Teachers;
    }
    
    public function byFaculty($facultyID)
    {
        if($facultyID != 0)
        {
            $teachers = $this->model->getTeachersByFaculty($facultyID);
            $i = 0;
            foreach($teachers as $row)
            {
                $i++;
                $teachersHandled[$i]['ID'] = $row['ID'];
                $teachersHandled[$i]['AccountID'] = $row['AccountID'];
                $teachersHandled[$i]['First'] = $row['First'];
                $teachersHandled[$i]['Second'] = $row['Second'];
                $teachersHandled[$i]['Last'] = $row['Last'];
                $teachersHandled[$i]['JobPositionName'] = $row['JobPositionName'];
                $teachersHandled[$i]['DepartmentID'] = $row['DepID'];
                $teachersHandled[$i]['DepartmentName'] = $row['DepName'];
            }                
        }
        return new DataArray_Result($teachersHandled);
    }
    
    public function byDepartment($departmentID)
    {
        $teachers = $this->model->getTeachersByDepartment($departmentID);
        $i = 0;
        foreach($teachers as $row)
        {
            $i++;
            $teachersHandled[$i]['ID'] = $row['ID'];
            $teachersHandled[$i]['AccountID'] = $row['AccountID'];
            $teachersHandled[$i]['First'] = $row['First'];
            $teachersHandled[$i]['Second'] = $row['Second'];
            $teachersHandled[$i]['Last'] = $row['Last'];
            $teachersHandled[$i]['JobPositionName'] = $row['JobPositionName'];
            $teachersHandled[$i]['DepartmentName'] = $row['DepName'];
        }
        return new DataArray_Result($teachersHandled);
    }
    
    public function forDiscipline($disciplineID, $asConcat = false, $asInitials = false)
    {
        $teachers = $this->model->getTeachersForDiscipline($disciplineID);
        $teachersHandled = array(); $i = 0;
        foreach ($teachers as $teacher)
        {
            $i++; $tchr = array();
            $tchr['isAuthor'] = $teacher['isAuthor'];
            $tchr['ID'] = $teacher['ID'];
            $tchr['Last'] = $teacher['Last'];
            $tchr['First'] = $asInitials ? 
                    UTF8::substr($teacher['First'], 0, 1).'. ' : $teacher['First'];
            if(!empty($teacher['Second']))
            $tchr['Second'] = $asInitials ? 
                    UTF8::substr($teacher['Second'], 0, 1).'. ' : $teacher['Second'];
            if($asConcat)
                $teachersHandled[$i] = $tchr['Last'].$tchr['First'].$tchr['Second'];
            else
                $teachersHandled[$i] = $tchr;
        }
        return new DataArray_Result($teachersHandled);
    }
    
}
